/*
 * guru.c
 *
 * Linux screenblanker guruguru
 *
 * (c)1996 Kawamoto Yasuhisa
 * E-mail: nanashi@yk.rim.or.jp
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>
#include <math.h>
#include <linux/delay.h>
#include "vga.h"

void handler(sig) {
#if 1
  vga_setmode(TEXT);
#endif
  exit(-1);
}

void pset(int x,int y,int c)
{
  if((x < 0) || (640 <= x)) return;
  if((y < 0) || (480 <= y)) return;
  vga_setcolor(c);
  vga_drawpixel(x,y);
}

#define PIXELMAX 1400

int main()
{
  int i,j,k,c;
  int x[PIXELMAX],y[PIXELMAX];
  vga_modeinfo *info;
  int colorMax;

  signal(SIGQUIT, handler);

  vga_init();	/* Initialize. */
#if 1
  i = G640x480x256;
  if(!vga_hasmode(i))
    i = G640x480x16;
  if(!vga_hasmode(i))
    return(-1);

  info = vga_getmodeinfo(i);
  colorMax = info->colors - 1;
  vga_setmode(i);

  for(k = 0;k < PIXELMAX;k++){
    x[k] = 0; y[k] = 0;
  }
  k = 0;
  c = 0;
  for(;;){
    for(i = 0;i < 360*5*11;i++){
      pset(x[k],y[k],0);
      x[k]  = 320;                          y[k]  = 240;
      x[k] += cos(i*2*3.14   /360/4) * 100; y[k] += sin(i*2*3.14   /360/4) * 100;
      x[k] += cos(i*2*3.14* 5/360/4) * 100; y[k] += sin(i*2*3.14* 5/360/4) * 100;
      x[k] -= cos(i*2*3.14/ 5/360/4) * 100; y[k] -= sin(i*2*3.14/ 5/360/4) * 100;
      x[k] += cos(i*2*3.14*11/360/4) * 100; y[k] += sin(i*2*3.14*11/360/4) * 100;
      x[k] -= cos(i*2*3.14/11/360/4) * 100; y[k] -= sin(i*2*3.14/11/360/4) * 100;
      c++; if(colorMax < c) c = 0;
      pset(x[k],y[k],c);
      k++; if(PIXELMAX <= k) k = 0;
    }
  }
#else
  for(;;){}
#endif
}
